--[[

Changes by sarf:

Added auto-config support. Will be determined on each cast (should not be a penalty).

Added out-of-range-check (requires that DD Action is present).

Added DoT check (for the "Shadow Word: Pain"/"Curse of Agony" spell).

--

Added Mana Spring totem

Removed Warlock DoTs

Added an optional DD Effect checking for the debuffs too (and hence restructured the UnitIsMarkedForDeath thingies).

]]--

--[[
Kill de totemz.

Edit with your own spell/shot if you need to, in the variables.

This is quick and dirty, by all means toss me a line at evilsmoo@gmail.com if you have a better idea.




Fire Blast(Rank 1) (for mages?)
Shoot Bow(Rank 1)  (for non-hunter guns?  need to test further.)


UnitClass("unit") - Returns the class name of the specified unit (e.g., "Warrior" or "Shaman").
   in case you want to set it up to use different spells by class....
]]

-- ***********************************


-- *******

-- End variables.

-- Variables
TKill = { };
TKill.automode = false;
TKill.mode = "PvP";
TKill.Retarget = true;  --Change this to false if you don't want to target your last enemy
TKill.TempTarget = "";
TKill.Hostile = false;
--I'd suggest using a fast-cast spell with as little cooldown as possible.
--Not sure about hunters, though...  :/   A shot spell works, but annoying cooldown.

-- This function will cast an appropriate spell from the spell list. 
-- It will even be able (with DynamicData Spell) to use "backup" spells in the case where a spell has a cooldown.
function TKill_CastSpell()
	local class = UnitClass("player");
	local inRange = false;
	if ( class ) and ( TKill_Spells[class] ) then
		for k, v in TKill_Spells[class] do
			inRange = true;
			local spellRank = TKill_Rank_String;
			local spellName = v;
			if ( type(spellName) == "table" ) then
				if ( v.name ) then
					spellName = v.name;
					spellRank = v.rank;
				elseif ( v.action ) then
					local func = v.action;
					if ( type(func) == "string" ) then
						func = getglobal(func);
					end
					if ( func ) then
						if ( v.actionArgs ) then
							func(unpack(v.actionArgs));
						else
							func();
						end
						return true;
					end
				end
			end
			if ( DynamicData ) and ( DynamicData.action ) and ( DynamicData.action.getSpellAsActionId ) then
				local actionId = DynamicData.action.getSpellAsActionId(spellName);
				if ( actionId ) and ( actionId >= 1 ) and ( IsActionInRange(actionId) ~= 1 ) then
					inRange = false;
				end
			end
			if ( inRange ) then
				if ( DynamicData ) and ( DynamicData.spell ) and ( DynamicData.spell.getMatchingSpellId ) then
					local spellId = DynamicData.spell.getMatchingSpellId(spellName, 1);
					if ( spellId ) then
						local start, duration, enable = GetSpellCooldown(spellId, BOOKTYPE_SPELL);
						if ( ( start+duration ) <= 0 ) then
							CastSpell(spellId, BOOKTYPE_SPELL);
							return true;
						end
					end
				else
					local n = spellName;
					if ( spellRank ) then
						n = n..spellRank;
					end
					CastSpellByName(n);
					return true;
				end
			end
		end
	end
	return false;
end


TKill_ZoneChangeEvents = {
	"ZONE_CHANGED",
	"ZONE_CHANGED_INDOORS",
	"ZONE_CHANGED_NEW_AREA"
};

function TKill_OnLoad()

	-- Register for Events
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("UNIT_PVP_UPDATE");
	for k, v in TKill_ZoneChangeEvents do
		this:RegisterEvent(v);
	end

	-- Register Slash Commands
	SLASH_TKILL1 = "/tkill";
	SlashCmdList["TKILL"] = function( msg )
		TKill_SlashMessageHandler(msg)
		--TKill_Kill();
	end
	DEFAULT_CHAT_FRAME:AddMessage("Totem Killer Active.");
	
	-- Set spell by class (default is druid  ;)
	--Self_Class = UnitClass("player");
	--Spellname = Class_Spells.Self_Class;
	
end

function TKill_IsInPvPMode()
	if ( TKill ) and ( TKill.mode == "PvP" ) then
		return true;
	else
		return false;
	end
end

function TKill_IsInAutoMode()
	if ( TKill ) then
		return TKill.automode;
	else
		return false;
	end
end

function TKill_Event_ZoneChanged()
	if ( TKill_IsInAutoMode() ) then
		local zoneText = GetZoneText();
		local newmode = nil;
		if ( TKill_TotemList[zoneText] ) then
			newmode = zoneText;
		end
		if ( newmode ) then
			if ( TKill_IsInPvPMode() ) then
				TKill.oldmode = newmode;
			else
				TKill.oldmode = TKill.mode;
				TKill.mode = newmode;
			end
		else
			if ( TKill_IsInPvPMode() ) then
				TKill.oldmode = "PvE";
			else
				TKill.mode = "PvE";
			end
		end
	end
end

function TKill_Event_PvP()
	if ( TKill_IsInAutoMode() ) then
		local factionGroup, factionName = UnitFactionGroup("player");
		if ( UnitIsPVPFreeForAll("player") ) or ( ( factionGroup ) and ( UnitIsPVP("player") ) ) then
			if ( TKill ) then
				TKill.oldmode = TKill.mode;
				TKill.mode = "PvP";
			end
		else
			if ( TKill ) then
				if ( TKill.oldmode ) then
					TKill.mode = TKill.oldmode;
				else
					TKill.mode = "PvE";
				end
			end
		end
	end
end

function TKill_OnEvent()
	-- Save Variables
	if ( event == "VARIABLES_LOADED") then
		--RegisterForSave("TKill");  --no point now since added to the .toc
		return;
	end
	if ( event == "UNIT_PVP_UPDATE" ) then
		TKill_Event_PvP();
		return;
	end
	-- Zone Changed events
	for k, v in TKill_ZoneChangeEvents do
		if ( event == v ) then
			TKill_Event_ZoneChanged();
			return;
		end
	end
end	

function TKill_UnitIsMarkedForDeath_DD_Effect(unit, debuffsList)
	if ( not unit ) or ( not debuffsList ) then
		return false;
	end
	if ( not DynamicData ) or ( not DynamicData.effect ) or ( not DynamicData.effect.hasEffectInfo ) then
		return false;
	end
	
	for k, debuffData in debuffsList do
		-- we could specify texture too, but there is no need to, besides, textures may change but names will (hopefully) stay the same
		if ( DynamicData.effect.hasEffectInfo(unit, debuffData.name) ) then
			return true;
		end
	end
	return false;
end

function TKill_GetTotemList()
	if ( not TKill ) then
		TKill = {};
	end
	if ( not TKill.mode ) then
		TKill.mode = "PvP";
	end
	if ( TKill_TotemList[TKill.mode] ) then
		return TKill_TotemList[TKill.mode];
	else
		for k, v in TKill_TotemList do
			return v;
		end
	end
end

-- Will detect if a DoT is on the totem and if so, skip it.
function TKill_UnitIsMarkedForDeath(unit)
	if ( not unit ) then
		return false;
	end
	-- performance increase - will only check for debuffs on classes that need it
	local class = UnitClass("player");
	if ( not class ) then
		return false;
	end
	if ( not TKill_UnitIsMarkedForDeath_Data ) then
		return false;
	end
	local list = TKill_UnitIsMarkedForDeath_Data[class];
	if ( not list ) then
		return false;
	end
	if ( DynamicData ) and ( DynamicData.effect ) and ( DynamicData.effect.hasEffectInfo ) then
		return TKill_UnitIsMarkedForDeath_DD_Effect(unit, list);
	end
	
	local i = 1;
	local debuff = UnitDebuff(unit, i);
	while debuff do
		for k, v in list do
			if ( string.find(debuff, v.texture) ) then
				return true;
			end
		end
		i = i + 1;
		debuff = UnitDebuff(unit, i);
	end
	return false;
end

function TKill_Kill()	-- You get the idea.  Check if it exists, if it does, kill.
	TKill.Hostile = false;
	TKill.TempTarget = UnitName("target");
	if UnitIsEnemy("player", "target") then
		TKill.Hostile = true;
	else
		TKill.Hostile = false;
	end
	--DEFAULT_CHAT_FRAME:AddMessage("ttarg is "..TKill.Temptarget.." forsooth!");  --debug
	local totemList = TKill_GetTotemList();
	for k, v in totemList do
		TargetUnit("player");
		TargetByName(v);
		--DEFAULT_CHAT_FRAME:AddMessage(v);  --only for debug.  very spammy.
		if ( not UnitIsDead("target") ) 
			and ( UnitIsEnemy("player", "target") ) 
			and ( not UnitIsPlayer("target") ) 
			and ( not TKill_UnitIsMarkedForDeath("target") )
			then
			TKill_CastSpell();  --Wham goes here.
			if ( TKill.Retarget and TKill.TempTarget ~= nil ) then 
				TargetByName(TKill.TempTarget);
			else
				ClearTarget();
			end
			return;
		end
		if TKill.Hostile then
			TargetLastEnemy();
		end
	end
	DEFAULT_CHAT_FRAME:AddMessage("Nothing found to kill.");
	if TKill.Hostile then
		return;
	end
	if ( TKill.Retarget and TKill.TempTarget ~= nil ) then 
		TargetByName(TKill.TempTarget);
	else
		ClearTarget();
	end
end

function TKill_Print(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 1, 0);
end

function TKill_Extract_NextParameter(msg)
	local params = msg;
	local command = params;
	local index = strfind(command, " ");
	if ( index ) then
		command = strsub(command, 1, index-1);
		params = strsub(params, index+1);
	else
		params = "";
	end
	return command, params;
end

function TKill_IsCommand(command, commandList)
	for k, v in commandList do
		if ( string.find(command, v) ) then
			return true;
		end
	end
end

function TKill_Slash_Usage()
	for k, v in TKill_Slash_Help do
		TKill_Print(v);
	end
end

function TKill_SlashMessageHandler(msg)
	if ( not msg ) or ( strlen(msg) <= 0 ) then
		TKill_Kill();
		return;
	else
		local command, params = TKill_Extract_NextParameter(msg);
		if ( TKill_IsCommand(command, TKill_Slash_Command_Kill) ) then
			TKill_Kill();
			return;
		end
		if ( TKill_IsCommand(command, TKill_Slash_Command_AutoMode) ) then
			if ( not TKill ) then
				TKill = {};
			end
			if ( TKill.automode ) then
				TKill.automode = false;
				toggle = TKill_Toggle_Disable;
			else
				TKill.automode = true;
				toggle = TKill_Toggle_Enable;
			end
			TKill_Print(string.format(TKill_AutoMode_Toggle, toggle));
			return;
		end
		if ( TKill_IsCommand(command, TKill_Slash_Command_ListMode) ) then
			TKill_Print(TKill_ListMode_Text);
			for k, v in TKill_TotemList do
				TKill_Print(k);
			end
			return;
		end
		if ( TKill_IsCommand(command, TKill_Slash_Command_Mode) ) then
			local outMsg = nil;
			if ( not TKill_TotemList[params] ) then
				if ( not params ) then params = "<NIL>"; end
				outMsg = string.format(TKill_Mode_NotFound, params);
			else
				if ( not TKill ) then
					TKill = {};
				end
				TKill.mode = params;
				outMsg = string.format(TKill_Mode_Switch, params);
			end
			TKill_Print(outMsg);
			return;
		end
		TKill_Slash_Usage();
	end
end